package VRML;

import java.util.*;
import java.io.*;


/**This clas must be extended to create an interface for the pdb parser
All the functions must be over ridden as ever if they are a void
function:
 Will have to import 
 java.io.*;
 java.util.*;
*/
abstract class vrmlInt
{
vrml parser;



/**What should be done with a Anchor node
@param A StringTokeniser which holds the remark string less the Anchor comment*/
public abstract void indexAnchor(String st , String description);

/**What the should done with a Text node 
@param A StringTokeniser which holds the text string less the Text comment*/
public abstract void indexText(String st);

/**What the item should do for a Viewpoint node
@param A StringTokeniser which holds the viewpoint string less the viewpoint comment*/
public abstract void indexViewpoint(String st);

/**What the item should do for a WorldInfo node
@param A StringTokeniser which holds the wordinfo string less the wordinfo comment*/
public abstract void indexWorldinfo(String st);


/**main control loop which runs the parser
e.g.
public void doit()
    {
    while(parser.ok)
	{
	parser.pdbRead();    
	}
    }
 */

abstract void doit();

/**Consturctor should be called but may not  */	
vrmlInt(String name)
    {
    // create the file
    File in = new File(name);
    // create the parser
    this.parser = new vrml(in,this);
    }  
}
