package chemical;

import java.util.*;
import java.io.*;
import java.lang.*;
import com.jobjects.quest.*;

/**This clas must be extended to create an interface for the dx parser
All the functions must be over ridden as ever if they are a void
function:
 Will have to import 
 java.io.*;
 java.util.*;
*/
class Jobjectdx extends dxInt
{
Resource docref;
// the labels which the data base will be indexed into
private String Owner;
private String Title;
private String Comment;
private String Type;

public void doit()
    {
    while(parser.ok)
	{
	parser.dxRead();    
	}
    }

/**What the item should do for a Remark comment 
@param A StringTokeniser which holds the remark string less the remark comment*/
public void indexComment(StringTokenizer st)
	{
	while (st.hasMoreTokens()) 
	    {
	    String blob = rep(checkString(st.nextToken()));
	    if(blob.length()>3)
		{
		try
		    {
		    docref.add(Comment, blob, 1); 
		    }
		catch(IOException e){}
		catch(QuestException e)
		    {
			
		    }
		}
	    }
	}


/**What the item should do for a TITLE comment 
@param A StringTokeniser which holds the remark string less the TITLE comment*/
public void indexTitle(StringTokenizer st)
	{
	
	// make a string
	String out = new String();
	while (st.hasMoreTokens()) 
	    {
	    // have to do this as htdig does not search titles
            String current = rep(checkString(st.nextToken()));
	    out+=current+" ";
	    
	    }
	 try{   
	 docref.add(Title, out, 1); 
	    }
	catch(IOException e){}
	catch(QuestException e)
		    {
			
		    } 
	}
/**What the item should do for a Type comment 
@param A StringTokeniser which holds the remark string less the TITLE comment*/
public void indexType(StringTokenizer st)
	{
	
	// make a string
	String out = new String();
	while (st.hasMoreTokens()) 
	    {
	    // have to do this as htdig does not search titles
            String current = rep(checkString(st.nextToken()));
	    out+=current+" ";
	    
	    }
	 try{   
	 docref.add(Type, out, 1); 
	    }
	catch(IOException e){}
	catch(QuestException e)
		    {
			
		    } 
	}	


/**What the item should do for a keywords comment 
@param A StringTokeniser which holds the remark string less the KEYWRD comment*/
public void indexOwner(StringTokenizer st)
    {
    while (st.hasMoreTokens()) 
	    {
            String blob = rep(checkString(st.nextToken()));
	    try{
             docref.add(Owner, blob,1 );
	     }
	     catch(IOException e){}
	     catch(QuestException e)
		    {
			
		    }
	    }	
    }


Jobjectdx(String name, Resource in)
    {
    super(name);
    this.docref = in;
    // set up the field names
    Owner = "body";
    Type = "body";
    Title= "body";
    Comment= "body";
    


    } 
      
private String checkString(String in )
    {
    // make sure that the word only has letters or numbers
    // at the ends as otherwise this causes problems
    // First start at front:
    while(true)
	{
	try{
	char ab = in.charAt(0);
	   if(!Character.isLetterOrDigit(ab))
		{
		// remove it	
		in = in.substring(1);
		}
	   else
		{
		break;	
		}
	   }
	catch( StringIndexOutOfBoundsException e)
	    {
	    break;	
	    }
	}	
    // check the tail
    while(true)
	{
	try{
	char ab = in.charAt(in.length()-1);
	   if(!Character.isLetterOrDigit(ab))
	    {
	    // remove it	
	    int place = in.length()-1;
	    in = in.substring(0, place);  
	    }
	   else
	    {
	    break;	
	    }
	   }
	catch( StringIndexOutOfBoundsException e)
	    {
	    break;	
	    }
	}	
    // make sure that there are no periods or commas replace with space
    return in;
    }

/**Replaces ',' and '.' in a string with spaces*/
private String rep(String in)
    {      
    String blob = in.replace('.',' ');
    in = blob.replace(',',' ');	 
    return in;
    }

}
