
package chemical;
import java.util.*;
import java.io.*;
import com.jobjects.quest.*; 
/**This is the fornt to the PDB parser for JObjects */

class Jobjectpdb extends pdbInt
    {
Resource docref;
// the labels which the data base will be indexed into
private String Remark;
private String Author;
private String Title;
private String Journal;
private String Keyword;
private String Exprimental;
private String Compound;

public void doit()
    {
    while(parser.ok)
	{
	parser.pdbRead();    
	}
    }
/**What the item should do for a Remark comment 
@param A StringTokeniser which holds the remark string less the remark comment*/
public void indexRemark(StringTokenizer st)
	{
	while (st.hasMoreTokens()) 
	    {
	    String blob = rep(checkString(st.nextToken()));
	    if(blob.length()>3)
		{
		try
		    {
		    docref.add(Remark, blob, 1); 
		    }
		catch(IOException e){}
		catch(QuestException e)
		    {
			
		    }
		}
	    }
	}


/**What the item should do for a AUTHOR comment 
@param A StringTokeniser which holds the remark string less the AUTHOR comment*/
public void indexAuthor(StringTokenizer st)
	{
	String out = new String();
	while (st.hasMoreTokens()) 
	    {
	    String word =st.nextToken(); 
	    String current = checkString(word);
            word = rep(current);
	    if(word.length()>3)
		{
		// if not equal must have a period or comma therefore need to find out and
		// substring the componets
		if(word.equals(current))
		    {
		    try{
		    docref.add(Author, word, 1);
			}
			catch(IOException e){
			}catch(QuestException e)
			{	
			
			} 
		    }
		else
		    {
		    // do it recusively!
		    indexAuthor(new StringTokenizer(word));  	
		    }
		}
	    }
	}

/**What the item should do for a TITLE comment 
@param A StringTokeniser which holds the remark string less the TITLE comment*/
public void indexTitle(StringTokenizer st)
	{
	
	// make a string
	String out = new String();
	while (st.hasMoreTokens()) 
	    {
	    // have to do this as htdig does not search titles
            String current = rep(checkString(st.nextToken()));
	    out+=current+" ";
	    
	    }
	 try{   
	 docref.add(Title, out, 1); 
	    }
	catch(IOException e){}
	catch(QuestException e)
		    {
			
		    } 
	}
	

/**What the item should do for a Journal comment 
@param A StringTokeniser which holds the remark string less the JRNL comment*/
public void indexJrnl(StringTokenizer st)
	{
	int a = 0 ;
	}

/**What the item should do for a keywords comment 
@param A StringTokeniser which holds the remark string less the KEYWRD comment*/
public void indexKeywds(StringTokenizer st)
    {
    while (st.hasMoreTokens()) 
	    {
            String blob = rep(checkString(st.nextToken()));
	    try{
             docref.add(Keyword, blob,1 );
	     }
	     catch(IOException e){}
	     catch(QuestException e)
		    {
			
		    }
	    }	
    }

/**What the item should do for a Compound  comment 
@param A StringTokeniser which holds the remark string less the compound comment*/
public void indexExpdta(StringTokenizer st)
    {
    int a = 1;
    }
    
public void indexCompnd(StringTokenizer st)
    {
    while (st.hasMoreTokens()) 
	    {
            String blob = rep(checkString(st.nextToken()));
            if(blob.length()>3)
	    try{
		 docref.add(Compound,blob,1);
		}
	    catch(IOException e){}
	    catch(QuestException e)
		    {
			
		    }
	    }		
    }

Jobjectpdb(String name, Resource in)
    {
    super(name);
    this.docref = in;
    // set up the field names
    Remark = "body";
    Author = "body";
    Title= "body";
    Journal= "body";
    Keyword= "body";
    Exprimental= "body";
    Compound= "body";


    } 
      
private String checkString(String in )
    {
    // make sure that the word only has letters or numbers
    // at the ends as otherwise this causes problems
    // First start at front:
    while(true)
	{
	try{
	char ab = in.charAt(0);
	   if(!Character.isLetterOrDigit(ab))
		{
		// remove it	
		in = in.substring(1);
		}
	   else
		{
		break;	
		}
	   }
	catch( StringIndexOutOfBoundsException e)
	    {
	    break;	
	    }
	}	
    // check the tail
    while(true)
	{
	try{
	char ab = in.charAt(in.length()-1);
	   if(!Character.isLetterOrDigit(ab))
	    {
	    // remove it	
	    int place = in.length()-1;
	    in = in.substring(0, place);  
	    }
	   else
	    {
	    break;	
	    }
	   }
	catch( StringIndexOutOfBoundsException e)
	    {
	    break;	
	    }
	}	
    // make sure that there are no periods or commas replace with space
    return in;
    }

/**Replaces ',' and '.' in a string with spaces*/
private String rep(String in)
    {      
    String blob = in.replace('.',' ');
    in = blob.replace(',',' ');	 
    return in;
    }
}
    
    
    
   
