
package VRML;
import java.util.*;
import java.io.*;
import com.jobjects.quest.*; 
/**This is the fornt to the PDB parser for JObjects */

public class Jobjectvrml extends vrmlInt
    {
Resource docref;
// the labels which the data base will be indexed into
    
private String worldinfo;
private String viewpoint;
private String text;


public void doit()
    {
    while(parser.ok)
	{
	parser.vrmlRead();    
	}
    }

    /**What should be done with a Anchor node
@param A StringTokeniser which holds the remark string less the Anchor comment*/
public  void indexAnchor(String str , String description)
    {
    // do nothing with URL as Jobjects does not do anything with URL
    // but index description
    
    StringTokenizer st = new StringTokenizer(description);
	// make a string
	try{ 	
	while (st.hasMoreTokens()) 
	    {
	    // have to do this as jobejcts does not search titles
            String current = rep(checkString(st.nextToken()));
	    
	     docref.add(text, current, 1); 
	    }
	   
	
	    }
	catch(IOException e){}
	catch(QuestException e){}
    }

/**What the should done with a Text node 
@param A StringTokeniser which holds the text string less the Text comment*/
public void indexText(String str)
	{
	StringTokenizer st = new StringTokenizer(str);
	// make a string
	try{ 	
	while (st.hasMoreTokens()) 
	    {
	    // have to do this as jobejcts does not search titles
            String current = rep(checkString(st.nextToken()));
	    
	     docref.add(text, current, 1); 
	    }
	   
	
	    }
	catch(IOException e){}
	catch(QuestException e){} 
	}
/**What the item should do for a Viewpoint node
@param A StringTokeniser which holds the viewpoint string less the viewpoint comment*/
public  void indexViewpoint(String str)
	{
	StringTokenizer st = new StringTokenizer(str);
	// make a string
	try{ 	
	while (st.hasMoreTokens()) 
	    {
	    // have to do this as jobejcts does not search titles
            String current = rep(checkString(st.nextToken()));
	    
	     docref.add(viewpoint, current, 1); 
	    }
	   
	
	    }
	catch(IOException e){}
	catch(QuestException e)
		    {
			
		    } 
	}
	
/**What the item should do for a WorldInfo node
@param A StringTokeniser which holds the wordinfo string less the wordinfo comment*/
public void indexWorldinfo(String str)
	{
	StringTokenizer st = new StringTokenizer(str);
	// make a string
	try{ 	
	while (st.hasMoreTokens()) 
	    {
	    // have to do this as jobejcts does not search titles
            String current = rep(checkString(st.nextToken()));
	    
	     docref.add(worldinfo, current, 1); 
	    }
	    }
	catch(IOException e)
		{
		}
	catch(QuestException e)
		    {
			
		    } 
	}



public Jobjectvrml(String name, Resource in)
    {
    super(name);
    this.docref = in;
    // set up the field names
    worldinfo = "body";
    viewpoint = "body";
    text= "body";
   


    } 
      
private String checkString(String in )
    {
    // make sure that the word only has letters or numbers
    // at the ends as otherwise this causes problems
    // First start at front:
    while(true)
	{
	try{
	char ab = in.charAt(0);
	   if(!Character.isLetterOrDigit(ab))
		{
		// remove it	
		in = in.substring(1);
		}
	   else
		{
		break;	
		}
	   }
	catch( StringIndexOutOfBoundsException e)
	    {
	    break;	
	    }
	}	
    // check the tail
    while(true)
	{
	try{
	char ab = in.charAt(in.length()-1);
	   if(!Character.isLetterOrDigit(ab))
	    {
	    // remove it	
	    int place = in.length()-1;
	    in = in.substring(0, place);  
	    }
	   else
	    {
	    break;	
	    }
	   }
	catch( StringIndexOutOfBoundsException e)
	    {
	    break;	
	    }
	}	
    // make sure that there are no periods or commas replace with space
    return in;
    }

/**Replaces ',' and '.' in a string with spaces*/
private String rep(String in)
    {      
    String blob = in.replace('.',' ');
    in = blob.replace(',',' ');	 
    return in;
    }
}
