package chemical;

import java.util.*;
import java.io.*;
import java.lang.*;

/**This clas must be extended to create an interface for the dx parser
All the functions must be over ridden as ever if they are a void
function:
 Will have to import 
 java.io.*;
 java.util.*;
*/
class Htdigdx extends dxInt
{

/**What the item should do for a Owner comment 
@param A StringTokeniser which holds the owner string less the owner comment*/
public  void indexOwner(StringTokenizer st)
    {
    while (st.hasMoreTokens()) 
	{
        System.out.println("w\t"+st.nextToken()+"\t0\t0\t");
	}	
    }


/**What the item should do for a TITLE comment 
@param A StringTokeniser which holds the remark string less the TITLE comment*/
public  void indexTitle(StringTokenizer st)
    {
    
    // make a string
    String out = new String();
    while (st.hasMoreTokens()) 
        {
        String current = st.nextToken();
	String blob = checkString(current);
	out+=blob+" ";
	System.out.println("w\t"+blob+"\t0\t1\t");        
	}
    System.out.print("t\t"+out+"\n");
    }
    
/**What the item should do for a Type  comment 
@param A StringTokeniser which holds the remark string less the TYPE comment*/
public  void indexType(StringTokenizer st)
    {
    while (st.hasMoreTokens()) 
	{
        System.out.println("w\t"+st.nextToken()+"\t0\t0\t");
	}
    }

/**main control loop which runs the parser
e.g.
public void doit()
    {
    while(parser.ok)
	{
	parser.dxRead();    
	}
    }
 */

public void doit()
    {
    while(parser.ok)
	{
	parser.dxRead();    
	}
    // HTdig has to have an excert therfoe make one up
    System.out.println("h\t This is a JCAMP dx file need to use the approapite "+
    "plugin to view");	
    }

private String checkString(String in )
    {
    // make sure that the word only has letters or numbers
    // at the ends as otherwise this causes problems
    // First start at front:
    while(true)
	{
	try{
	char ab = in.charAt(0);
	   if(!Character.isLetterOrDigit(ab))
		{
		// remove it	
		in = in.substring(1);
		}
	   else
		{
		break;	
		}
	   }
	catch( StringIndexOutOfBoundsException e)
	    {
	    break;	
	    }
	}	
    // check the tail
    while(true)
	{
	try{
	char ab = in.charAt(in.length()-1);
	   if(!Character.isLetterOrDigit(ab))
	    {
	    // remove it	
	    int place = in.length()-1;
	    in = in.substring(0, place);  
	    }
	   else
	    {
	    break;	
	    }
	   }
	catch( StringIndexOutOfBoundsException e)
	    {
	    break;	
	    }
	}	
    return in;
    }

/**Consturctor String file name */	
Htdigdx(String name)
    {
    super(name);
    }   

}
