package chemical;

import java.util.*;
import java.io.*;


/**This clas must be extended to create an interface for the dx parser
All the functions must be over ridden as ever if they are a void
function:
 Will have to import 
 java.io.*;
 java.util.*;
*/
abstract class dxInt
{
dx parser;


/**What the item should do for a Owner comment 
@param A StringTokeniser which holds the owner string less the owner comment*/
public abstract void indexOwner(StringTokenizer st);

/**What the item should do for a TITLE comment 
@param A StringTokeniser which holds the remark string less the TITLE comment*/
public abstract void indexTitle(StringTokenizer st);

/**What the item should do for a Type  comment 
@param A StringTokeniser which holds the remark string less the EXPDTA comment*/
public abstract void indexType(StringTokenizer st);

/**main control loop which runs the parser
e.g.
public void doit()
    {
    while(parser.ok)
	{
	parser.dxRead();    
	}
    }
 */

abstract void doit();

/**Consturctor should be called but may not  */	
dxInt(String name)
    {
    // create the file
    File in = new File(name);
    // create the parser
    this.parser = new dx(in,this);
    }   

}
